recipe/urls.py
from django.urls import path
from . import views
from recipe.views import recipe_detail
from recipe.api.views import NoteListCreateAPIView
from django.conf import settings
from django.conf.urls.static import static
from .views import delete_recipe, ChangePasswordView, NoteCreateAPIView, search_recipes, search_by_ingredient

app_name = 'recipe'

urlpatterns = [
    
    path('', views.home, name='home'),
    path('register/', views.register, name='register'),
    path('login/', views.login, name='login'),
    path('profile/', views.profile, name='profile'),
    path('logoff/', views.logoff, name='logoff'),
    path('add-recipe/', views.add_recipe, name='add_recipe'),
    path('recipe/<int:recipe_id>/', views.recipe_detail, name='recipe_detail'),
    path('notes/', NoteListCreateAPIView.as_view(), name='notes'),
    path('notes/<int:pk>/', views.NoteRetrieveUpdateDestroyAPIView.as_view(), name='note_detail'),
    path('recipe/delete/<int:recipe_id>/', delete_recipe, name='delete-recipe'),
    path('profile/update/', views.update_profile, name='update_profile'),
    path('about/', views.about, name='about'),
    path('change-password/', ChangePasswordView.as_view(), name='change_password'),
    path('api/notes/', NoteCreateAPIView.as_view(), name='create-note'),
    path('notes/create/', views.create_note, name='create_note'),
    path('search/', views.search_recipes, name='search'),
    path('search-by-ingredient/', search_by_ingredient, name='search_by_ingredient'),

] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

recipes/urls.py
from django.contrib import admin
from django.urls import include, path
from django.conf import settings
from django.conf.urls.static import static

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('recipe.urls', namespace='recipe')),
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

recipe/models.py
from django.db import models
from django.contrib.auth.models import User
from django.utils import timezone

class Recipe(models.Model):
    name = models.CharField(max_length=255)
    ingredients = models.TextField()
    details = models.TextField()
    picture = models.ImageField(upload_to='recipe_pictures')


    def __str__(self):
        return self.name


class Note(models.Model):
    user = models.ForeignKey(User, on_delete=models.CASCADE, default=1)
    theme = models.CharField(max_length=255)
    content = models.TextField()
    created_at = models.DateTimeField(default=timezone.now)
    updated_at = models.DateTimeField(auto_now=True)

    def __str__(self):
        return self.theme

    

class Profile(models.Model):
    user = models.OneToOneField(User, on_delete=models.CASCADE)
    name = models.CharField(max_length=255)
    surname = models.CharField(max_length=255)


    def __str__(self):
        return f"{self.name} {self.surname}"

recipe/forms.py
from django import forms
from recipe.models import Recipe
from django.contrib.auth.forms import UserChangeForm, PasswordChangeForm
from django.contrib.auth.models import User
from .models import Note

class NoteForm(forms.ModelForm):
    class Meta:
        model = Note
        fields = ['theme', 'content']

class RecipeForm(forms.ModelForm):
    class Meta:
        model = Recipe
        fields = ['name', 'ingredients', 'details', 'picture']

class RegistrationForm(forms.Form):
    username = forms.CharField(max_length=100)
    password = forms.CharField(widget=forms.PasswordInput)
    first_name = forms.CharField(max_length=100)
    last_name = forms.CharField(max_length=100)



class ProfileUpdateForm(UserChangeForm):
    class Meta:
        model = User
        fields = ('first_name', 'last_name')


class PasswordUpdateForm(PasswordChangeForm):
    class Meta:
        model = User


class CustomPasswordChangeForm(PasswordChangeForm):
    def clean_new_password2(self):
        password1 = self.cleaned_data.get('new_password1')
        password2 = self.cleaned_data.get('new_password2')

        if password1 and password2 and password1 != password2:
            raise forms.ValidationError("The two password fields didn't match.")
        return password2

class ProfileForm(forms.ModelForm):
    class Meta:
        model = User
        fields = ['first_name', 'last_name']

class PasswordForm(PasswordChangeForm):
    def __init__(self, user, *args, **kwargs):
        super().__init__(user, *args, **kwargs)
        del self.fields['username'] 

    class Meta:
        model = User
        fields = ['password']

recipe/api/views.py
from rest_framework import generics
from recipe.models import Note
from recipe.serializers import NoteSerializer

class NoteListCreateAPIView(generics.ListCreateAPIView):
    queryset = Note.objects.all()
    serializer_class = NoteSerializer

class NoteRetrieveUpdateDestroyAPIView(generics.RetrieveUpdateDestroyAPIView):
    queryset = Note.objects.all()
    serializer_class = NoteSerializer

recipe/views.py
from django.shortcuts import render, redirect,  get_object_or_404
from django.contrib import messages
from django.contrib.auth.models import User
from django.contrib.auth import authenticate, logout, login as auth_login
from django.contrib.auth.decorators import login_required
from django.contrib.auth.forms import PasswordChangeForm
from django.urls import reverse, reverse_lazy
from django.contrib.auth.views import PasswordChangeView
from recipe.forms import RecipeForm
from recipe.models import Recipe, Note
from django.http import HttpResponse
from .models import Recipe, Profile
from .forms import ProfileUpdateForm, PasswordUpdateForm, CustomPasswordChangeForm, RegistrationForm
from recipe.serializers import NoteSerializer
from rest_framework import generics, permissions
from recipe.serializers import NoteSerializer

from rest_framework.views import APIView
from rest_framework.response import Response
from rest_framework.permissions import IsAuthenticated
from .serializers import NoteSerializer


class ChangePasswordView(PasswordChangeView):
    template_name = 'change_password.html'
    success_url = reverse_lazy('recipe:profile')

def home(request):
    recipes = Recipe.objects.all()
    return render(request, 'home.html', {'recipes': recipes})

def register(request):
    if request.method == 'POST':
        form = RegistrationForm(request.POST)
        if form.is_valid():
            username = form.cleaned_data['username']
            password = form.cleaned_data['password']
            first_name = form.cleaned_data['first_name']
            last_name = form.cleaned_data['last_name']

            if User.objects.filter(username=username).exists():
                message = 'Username is not available. Please choose another username.'
                return render(request, 'register.html', {'form': form, 'message': message})

            user = User.objects.create_user(username=username, password=password, first_name=first_name, last_name=last_name)

            profile = Profile(user=user)
            profile.save()

            return redirect('recipe:home')
    else:
        form = RegistrationForm()

    return render(request, 'register.html', {'form': form})


def login(request):
    if request.method == 'POST':
        username = request.POST.get('username')
        password = request.POST.get('password')

        user = authenticate(request, username=username, password=password)

        if user is not None:
            auth_login(request, user)
            return redirect(reverse('recipe:home'))
        else:
            messages.error(request, 'Invalid login credentials. Please try again.')

    return render(request, 'login.html')



def profile(request):
    user = request.user  

    context = {
        'user': user
    }

    return render(request, 'profile.html', context)

def logoff(request):
    logout(request)
    return redirect('recipe:home')


def add_recipe(request):
    if request.method == 'POST':
        form = RecipeForm(request.POST, request.FILES)
        if form.is_valid():
            recipe = form.save(commit=False)
            recipe.user = request.user
            recipe.save()
            return redirect('recipe:home')
    else:
        form = RecipeForm()
    return render(request, 'add_recipe.html', {'form': form})



def recipe_detail(request, recipe_id):
    recipe = get_object_or_404(Recipe, id=recipe_id)
    return render(request, 'recipe_detail.html', {'recipe': recipe})


def notes(request):
    notes = Note.objects.all()
    return render(request, 'notes.html', {'notes': notes})


class NoteListCreateAPIView(generics.ListCreateAPIView):
    queryset = Note.objects.all()
    serializer_class = NoteSerializer
    permission_classes = [permissions.IsAuthenticated]

    def perform_create(self, serializer):
        serializer.save(user=self.request.user)

class NoteRetrieveUpdateDestroyAPIView(generics.RetrieveUpdateDestroyAPIView):
    queryset = Note.objects.all()
    serializer_class = NoteSerializer
    

def delete_recipe(request, recipe_id):
    recipe = Recipe.objects.get(id=recipe_id)
    recipe.delete()
    return redirect('recipe:home')

def update_profile(request):
    if request.method == 'POST':
        form = ProfileUpdateForm(request.POST, instance=request.user)
        if form.is_valid():
            form.save()
            return redirect('recipe:profile')
    else:
        form = ProfileUpdateForm(instance=request.user)
    
    return render(request, 'update_profile.html', {'form': form})


def about(request):
    return render(request, 'about.html')


class NoteCreateAPIView(APIView):
    permission_classes = [IsAuthenticated]

    def post(self, request):
        serializer = NoteSerializer(data=request.data)
        if serializer.is_valid():
            serializer.save(user=request.user)
            return Response(serializer.data, status=201)
        return Response(serializer.errors, status=400)
    
    
@login_required
def create_note(request):
    if request.method == 'POST':
        form = NoteForm(request.POST)
        if form.is_valid():
            note = form.save(commit=False)
            note.user = request.user  
            note.save()
            return redirect('recipe:notes')
    else:
        form = NoteForm()

    return render(request, 'create_note.html', {'form': form})


def search_recipes(request):
    query = request.GET.get('search_query')
    if query:
        recipes = Recipe.objects.filter(name__icontains=query)
    else:
        recipes = Recipe.objects.all()
    
    context = {'recipes': recipes, 'query': query}
    return render(request, 'home.html', context)

from django.db.models import Q
import re

def search_by_ingredient(request):
    query = request.GET.get('ingredient_query')
    if query:
        ingredients = query.split()
        query_parts = [f'(?i)(?=.*\\b{re.escape(ingredient)}\\b)' for ingredient in ingredients]
        query_regex = ''.join(query_parts)
        recipes = Recipe.objects.filter(Q(ingredients__iregex=query_regex))
    else:
        recipes = Recipe.objects.all()

    context = {'recipes': recipes, 'query': query}
    return render(request, 'search_by_ingredient.html', context)

recipe/templates/about.html
<!DOCTYPE html>
<html>
<head>
  <title>About the Author</title>
  <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/css/bootstrap.min.css">
  <style>
    /* Custom CSS Styles */
    .author-info {
      font-size: 20px;
      font-family: 'Arial', sans-serif;
    }
  </style>
</head>
<body>
  <div class="container">
    <h1>About the Author</h1>
    <div class="row">
      <div class="col-md-6">
        <img src="https://res.cloudinary.com/dr1zjd8ze/image/upload/v1684707502/asd_vqpffv.png" alt="Arystan Zhulumbetov" class="img-fluid">
      </div>
      <div class="col-md-6">
        <p class="author-info">
          Hello! I'm Arystan Zhulumbetov. I am passionate about basketball, cooking, and data science. 
          In my free time, you can find me on the basketball court shooting hoops or experimenting with new recipes in the kitchen.
          I am also fascinated by the field of data science and enjoy working with data to derive insights and make data-driven decisions.
        </p>
        <a href="{% url 'recipe:home' %}" class="btn btn-primary">Go Back to Homepage</a>
      </div>
    </div>
  </div>

  <script src="https://code.jquery.com/jquery-3.5.1.slim.min.js"></script>
  <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/js/bootstrap.min.js"></script>
</body>
</html>

recipe/templates/add_recipe.html
<!DOCTYPE html>
<html>
<head>
  <title>Add Recipe</title>
  <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/css/bootstrap.min.css">
</head>
<body>
  <div class="container">
    <h1>Add Recipe</h1>
    <form method="post" enctype="multipart/form-data">
      {% csrf_token %}
      <div class="form-group">
        <label for="name">Name</label>
        <input type="text" class="form-control" id="name" name="name" required>
      </div>
      <div class="form-group">
        <label for="ingredients">Ingredients</label>
        <textarea class="form-control" id="ingredients" name="ingredients" rows="4" required></textarea>
      </div>
      <div class="form-group">
        <label for="details">Details</label>
        <textarea class="form-control" id="details" name="details" rows="6" required></textarea>
      </div>
      <div class="form-group">
        <label for="picture">Picture</label>
        <input type="file" class="form-control-file" id="picture" name="picture" accept="image/*" required>
      </div>
      <button type="submit" class="btn btn-primary">Save Recipe</button>
    </form>
  </div>

  <script src="https://code.jquery.com/jquery-3.5.1.slim.min.js"></script>
  <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/js/bootstrap.min.js"></script>
</body>
</html>

recipe/templates/change_password.html
<!DOCTYPE html>
<html>
<head>
  <title>Change Password</title>
  <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/css/bootstrap.min.css">
</head>
<body>
  <div class="container">
    <h1>Change Password</h1>
    <form method="post">
      {% csrf_token %}
      {{ form.as_p }}
      <button type="submit" class="btn btn-primary">Save</button>
    </form>
  </div>

  <script src="https://code.jquery.com/jquery-3.5.1.slim.min.js"></script>
  <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/js/bootstrap.min.js"></script>
</body>
</html>

recipe/templates/create_note.html
<!DOCTYPE html>
<html>
<head>
  <title>Create Note</title>
</head>
<body>
  <h1>Create Note</h1>
  <form method="post">
    {% csrf_token %}
    {{ form.as_p }}
    <button type="submit">Create</button>
  </form>
</body>
</html>

recipe/templates/home.html
<!DOCTYPE html>
<html>
<head>
  <title>Recipes App</title>
  <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/css/bootstrap.min.css">
  <style>
    /* Custom CSS Styles */
    .recipe-image {
      width: 200px;
      height: 200px;
      object-fit: cover;
      display: block;
      margin-left: auto;
      margin-right: auto;
      margin-top: 20px;
    }
  </style>
</head>
<body>
  <nav class="navbar navbar-expand-lg navbar-light bg-light">
    <div class="container">
      <a class="navbar-brand" href="{% url 'recipe:home' %}">Homepage</a>
      <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarNav" aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
        <span class="navbar-toggler-icon"></span>
      </button>
      <div class="collapse navbar-collapse justify-content-end" id="navbarNav">
        <ul class="navbar-nav">
          {% if user.is_authenticated %}
          {% comment %} <li class="nav-item">
            <a class="nav-link" href="{% url 'recipe:notes' %}">My Notes</a>
          </li> {% endcomment %}
          {% endif %}
          <li class="nav-item">
            <a class="nav-link" href="{% url 'recipe:about' %}">About the Author</a>
          </li>
          {% comment %} <li class="nav-item">
            <a class="nav-link" href="{% url 'recipe:home' %}">Recipes</a>
          </li> {% endcomment %}
          {% if user.is_authenticated %}
          <li class="nav-item">
            <a class="nav-link" href="{% url 'recipe:profile' %}">Profile</a>
          </li>
          <li class="nav-item">
            <a class="nav-link" href="{% url 'recipe:add_recipe' %}">Add Recipe</a>
          </li>
          <li class="nav-item">
            <a class="nav-link" href="{% url 'recipe:logoff' %}">Log Off</a>
          </li>
          {% else %}
          <li class="nav-item">
            <a class="nav-link" href="{% url 'recipe:register' %}">Register</a>
          </li>
          <li class="nav-item">
            <a class="nav-link" href="{% url 'recipe:login' %}">Login</a>
          </li>
          {% endif %}
        </ul>
      </div>
    </div>
  </nav>

  <div class="container">
    <h1 class="text-center" style="margin-top:10px;">Welcome to the Recipes App</h1>

    <form class="form-inline justify-content-center mt-4" action="{% url 'recipe:search' %}" method="GET">
      <input class="form-control mr-sm-2" type="text" name="search_query" placeholder="Search by recipe name" aria-label="Search">
      <button class="btn btn-primary" type="submit">Search</button>
    </form>

    <form class="form-inline justify-content-center mt-4" action="{% url 'recipe:search_by_ingredient' %}" method="get">
      <input class="form-control mr-sm-2" type="text" name="ingredient_query" placeholder="Search by ingredient">
      <button class="btn btn-primary" type="submit">Search</button>
    </form>

    <div class="container mt-4">
      <h2 class="text-center">Recipes</h2>
      <div class="row">
        {% for recipe in recipes %}
        <div class="col-md-3">
          <div class="card mb-4">
            <img src="{{ recipe.picture.url }}" class="card-img-top recipe-image mx-auto" alt="{{ recipe.name }}">
            <div class="card-body d-flex flex-column align-items-center">
              <h5 class="card-title">{{ recipe.name }}</h5>
              <p class="card-text">{{ recipe.description }}</p>
              <a href="{% url 'recipe:recipe_detail' recipe.id %}" class="btn btn-primary" style="width:150px;">View Recipe</a>
              {% if user.is_authenticated %}
              <form action="{% url 'recipe:delete-recipe' recipe.id %}" method="post">
                {% csrf_token %}
                <button type="submit" class="btn btn-danger" style="width:150px; margin-top:10px;">Delete Recipe</button>
              </form>
              {% endif %}
            </div>
          </div>
        </div>
        {% endfor %}
      </div>
    </div>
  </div>

  <script src="https://code.jquery.com/jquery-3.5.1.slim.min.js"></script>
  <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/js/bootstrap.min.js"></script>
</body>
</html>

recipe/templates/login.html
<!DOCTYPE html>
<html>
<head>
  <title>Login - Recipes App</title>
  <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/css/bootstrap.min.css">

</head>
<body>
  <nav class="navbar navbar-expand-lg navbar-light bg-light">
    <div class="container">
      <a class="navbar-brand" href="{% url 'recipe:home' %}">Homepage</a>
      <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarNav" aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
        <span class="navbar-toggler-icon"></span>
      </button>
      <div class="collapse navbar-collapse justify-content-end" id="navbarNav">
        <ul class="navbar-nav">
          <li class="nav-item">
            <a class="nav-link" href="{% url 'recipe:home' %}">Recipes</a>
          </li>
          <li class="nav-item">
            <a class="nav-link" href="{% url 'recipe:register' %}">Register</a>
          </li>
          <li class="nav-item">
            <a class="nav-link" href="{% url 'recipe:login' %}">Login</a>
          </li>
        </ul>
      </div>
    </div>
  </nav>

  <div class="container">
    <h1>Login</h1>
    {% if messages %}
    <div class="alert alert-danger" role="alert">
      {% for message in messages %}
        {{ message }}
      {% endfor %}
    </div>
    {% endif %}
    <form method="post">
      {% csrf_token %}
      <div class="form-group">
        <label for="username">Username</label>
        <input type="text" class="form-control" id="username" name="username" placeholder="Enter your username" required>
      </div>
      <div class="form-group">
        <label for="password">Password</label>
        <input type="password" class="form-control" id="password" name="password" placeholder="Enter your password" required>
      </div>
      <button type="submit" class="btn btn-primary">Login</button>
    </form>
  </div>

  <script src="https://code.jquery.com/jquery-3.5.1.slim.min.js"></script>
  <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/js/bootstrap.min.js"></script>
</body>
</html>

recipe/templates/notes.html
<!DOCTYPE html>
<html>
<head>
  <title>My Notes</title>
  <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/css/bootstrap.min.css">
</head>
<body>
  <div class="container">
    <h1>My Notes</h1>
    <table class="table">
      <thead>
        <tr>
          <th>Note</th>
          <th>Created</th>
          <th>Last Updated</th>
        </tr>
      </thead>
      <tbody>
        {% for note in notes %}
        <tr>
          <td>{{ note.content }}</td>
          <td>{{ note.created }}</td>
          <td>{{ note.updated }}</td>
        </tr>
        {% endfor %}
      </tbody>
    </table>
    <a href="{% url 'recipe:home' %}" class="btn btn-primary">Go Back</a>
  </div>

  <script src="https://code.jquery.com/jquery-3.5.1.slim.min.js"></script>
  <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/js/bootstrap.min.js"></script>
</body>
</html>

recipe/templates/profile.html
<!DOCTYPE html>
<html>
<head>
  <title>Profile</title>
  <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/css/bootstrap.min.css">
</head>
<body>
  <div class="container">
    <h1>Profile</h1>
    <p><strong>Name:</strong> {{ user.first_name }}</p>
    <p><strong>Surname:</strong> {{ user.last_name }}</p>
    <p><strong>Username:</strong> {{ user.username }}</p>
    
    <a href="{% url 'recipe:home' %}" class="btn btn-primary">Go Back</a>
    <a href="{% url 'recipe:update_profile' %}" class="btn btn-secondary">Update</a>
    <a href="{% url 'recipe:change_password' %}" class="btn btn-primary">Change Password</a>
  </div>

  <script src="https://code.jquery.com/jquery-3.5.1.slim.min.js"></script>
  <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/js/bootstrap.min.js"></script>
</body>
</html>

recipe/templates/recipe_detail.html
<!DOCTYPE html>
<html>
<head>
  <title>Recipe Detail</title>
  <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/css/bootstrap.min.css">
  <style>
    /* Custom CSS Styles */
    .recipe-image {
      width: 400px;
      height: 400px;
      object-fit: contain;
    }
  </style>
</head>
<body>
  <div class="container">
    <h1>{{ recipe.name }}</h1>
    <img src="{{ recipe.picture.url }}" alt="{{ recipe.name }}" class="img-fluid recipe-image">
    <h3>Ingredients:</h3>
    <p>{{ recipe.ingredients }}</p>
    <h3>Details:</h3>
    <p>{{ recipe.details }}</p>
    <a href="{% url 'recipe:home' %}" class="btn btn-primary">Go Back to Homepage</a>
  </div>

  <script src="https://code.jquery.com/jquery-3.5.1.slim.min.js"></script>
  <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/js/bootstrap.min.js"></script>
</body>
</html>

recipe/templates/register.html
<!DOCTYPE html>
<html>
<head>
  <title>Register - Recipes App</title>
  <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/css/bootstrap.min.css">
</head>
<body>
  <nav class="navbar navbar-expand-lg navbar-light bg-light">
    <div class="container">
      <a class="navbar-brand" href="{% url 'recipe:home' %}">Homepage</a>
      <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarNav" aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
        <span class="navbar-toggler-icon"></span>
      </button>
      <div class="collapse navbar-collapse justify-content-end" id="navbarNav">
        <ul class="navbar-nav">
          <li class="nav-item">
            <a class="nav-link" href="{% url 'recipe:home' %}">Recipes</a>
          </li>
          <li class="nav-item">
            <a class="nav-link" href="{% url 'recipe:register' %}">Register</a>
          </li>
          <li class="nav-item">
            <a class="nav-link" href="#">Login</a>
          </li>
        </ul>
      </div>
    </div>
  </nav>

  <div class="container">
    <h1>Register</h1>
    {% if message %}
      <p class="text-danger">{{ message }}</p>
    {% endif %}
    <form method="post">
      {% csrf_token %}
      <div class="form-group">
        <label for="first_name">First Name</label>
        <input type="text" class="form-control" id="first_name" name="first_name" placeholder="Enter your first name" required>
      </div>
      <div class="form-group">
        <label for="last_name">Last Name</label>
        <input type="text" class="form-control" id="last_name" name="last_name" placeholder="Enter your last name" required>
      </div>
      <div class="form-group">
        <label for="username">Username</label>
        <input type="text" class="form-control" id="username" name="username" placeholder="Enter a username" required>
      </div>
      <div class="form-group">
        <label for="password">Password</label>
        <input type="password" class="form-control" id="password" name="password" placeholder="Enter a password" required>
      </div>
      <button type="submit" class="btn btn-primary">Register</button>
    </form>
  </div>

  <script src="https://code.jquery.com/jquery-3.5.1.slim.min.js"></script>
  <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/js/bootstrap.min.js"></script>
</body>
</html>

recipe/templates/search_by_ingredient.html
<!DOCTYPE html>
<html>
<head>
  <title>Recipes App - Search by Ingredient</title>
  <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/css/bootstrap.min.css">
  <style>
    /* Custom CSS Styles */
    .recipe-image {
      width: 200px;
      height: 200px;
      object-fit: cover;
      display: block;
      margin-left: auto;
      margin-right: auto;
      margin-top: 20px;
    }
  </style>
</head>
<body>
  <div class="container">
    <h1>Search Recipes by Ingredient</h1>
    <form class="form-inline mb-3" action="{% url 'recipe:search_by_ingredient' %}" method="get">
      <div class="form-group mr-2">
        <input class="form-control" type="text" name="ingredient_query" placeholder="Enter ingredient">
      </div>
      <button class="btn btn-primary" type="submit">Search</button>
    </form>
    
    {% if query %}
      <h2>Search Results for Ingredient: {{ query }}</h2>
    {% endif %}
    
    <div class="row">
      {% for recipe in recipes %}
        <div class="col-md-3">
          <div class="card mb-4">
            <img src="{{ recipe.picture.url }}" class="card-img-top recipe-image mx-auto" alt="{{ recipe.name }}">
            <div class="card-body d-flex flex-column align-items-center">
              <h5 class="card-title">{{ recipe.name }}</h5>
              <p class="card-text">{{ recipe.description }}</p>
              <a href="{% url 'recipe:recipe_detail' recipe.id %}" class="btn btn-primary" style="width:150px;">View Recipe</a>
              {% if user.is_authenticated %}
              <form action="{% url 'recipe:delete-recipe' recipe.id %}" method="post">
                {% csrf_token %}
                <button type="submit" class="btn btn-danger" style="width:150px; margin-top:10px;">Delete Recipe</button>
              </form>
              {% endif %}
            </div>
          </div>
        </div>
      {% empty %}
        <p>No recipes found.</p>
      {% endfor %}
    </div>
    
    <div class="text-right mt-3">
      <a href="{% url 'recipe:home' %}" class="btn btn-secondary">Back to Homepage</a>
    </div>
  </div>

  <script src="https://code.jquery.com/jquery-3.5.1.slim.min.js"></script>
  <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/js/bootstrap.min.js"></script>
</body>
</html>

recipe/templates/update_profile.html
<!DOCTYPE html>
<html>
<head>
  <title>Update Profile</title>
  <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/css/bootstrap.min.css">
</head>
<body>
  <div class="container">
    <h1>Update Profile</h1>
    <form method="post">
      {% csrf_token %}
      {{ form.first_name.label_tag }}
      {{ form.first_name }}
      <br>
      {{ form.last_name.label_tag }}
      {{ form.last_name }}
      <br>
      <button type="submit" class="btn btn-primary">Save</button>
      <a href="{% url 'recipe:profile' %}" class="btn btn-secondary">Cancel</a>
    </form>
  </div>

  <script src="https://code.jquery.com/jquery-3.5.1.slim.min.js"></script>
  <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/js/bootstrap.min.js"></script>
</body>
</html>